
//Change this to true for a stretchy canvas!
//
var RESIZEABLE_CANVAS=false;

//Start us up!
//
window.onload=function( e ){

	if( RESIZEABLE_CANVAS ){
		window.onresize=function( e ){
			var canvas=document.getElementById( "GameCanvas" );

			//This vs window.innerWidth, which apparently doesn't account for scrollbar?
			var width=document.body.clientWidth;
			
			//This vs document.body.clientHeight, which does weird things - document seems to 'grow'...perhaps canvas resize pushing page down?
			var height=window.innerHeight;			

			canvas.width=width;
			canvas.height=height;
		}
		window.onresize( null );
	}
	
	game_canvas=document.getElementById( "GameCanvas" );
	
	game_console=document.getElementById( "GameConsole" );

	try{
	
		bbInit();
		bbMain();
		
		if( game_runner!=null ) game_runner();
		
	}catch( err ){
	
		showError( err );
	}
}

//Globals
var game_canvas;
var game_console;
var game_runner;

//${METADATA_BEGIN}
var META_DATA="[bat.png];type=image/png;width=240;height=35;\n[cactus.png];type=image/png;width=60;height=70;\n[car.png];type=image/png;width=128;height=128;\n[car2.png];type=image/png;width=128;height=128;\n[cruci.png];type=image/png;width=32;height=32;\n[eyes.png];type=image/png;width=192;height=24;\n[mojo_font.png];type=image/png;width=864;height=13;\n[mountains.png];type=image/png;width=700;height=64;\n[road1 copy.png];type=image/png;width=128;height=16;\n[road1.png];type=image/png;width=128;height=16;\n[road2 copy.png];type=image/png;width=128;height=16;\n[road2.png];type=image/png;width=128;height=16;\n[tower.png];type=image/png;width=64;height=256;\n[wheels.png];type=image/png;width=128;height=128;\n[wolf.png];type=image/png;width=32;height=32;\n";

//${METADATA_END}
function getMetaData( path,key ){	
	var i=META_DATA.indexOf( "["+path+"]" );
	if( i==-1 ) return "";
	i+=path.length+2;

	var e=META_DATA.indexOf( "\n",i );
	if( e==-1 ) e=META_DATA.length;

	i=META_DATA.indexOf( ";"+key+"=",i )
	if( i==-1 || i>=e ) return "";
	i+=key.length+2;

	e=META_DATA.indexOf( ";",i );
	if( e==-1 ) return "";

	return META_DATA.slice( i,e );
}

function loadString( path ){
	if( path=="" ) return "";
//${TEXTFILES_BEGIN}
		return "";

//${TEXTFILES_END}
}

function loadImage( path,onloadfun ){
	var ty=getMetaData( path,"type" );
	if( ty.indexOf( "image/" )!=0 ) return null;

	var image=new Image();
	
	image.meta_width=parseInt( getMetaData( path,"width" ) );
	image.meta_height=parseInt( getMetaData( path,"height" ) );
	image.onload=onloadfun;
	image.src="data/"+path;
	
	return image;
}

function loadAudio( path ){
	var audio=new Audio( "data/"+path );
	return audio;
}

//${TRANSCODE_BEGIN}

// Javascript Monkey runtime.
//
// Placed into the public domain 24/02/2011.
// No warranty implied; use at your own risk.

//***** JavaScript Runtime *****

var D2R=0.017453292519943295;
var R2D=57.29577951308232;

var err_info="";
var err_stack=[];

function push_err(){
	err_stack.push( err_info );
}

function pop_err(){
	err_info=err_stack.pop();
}

function stackTrace(){
	var str="";
	push_err();
	err_stack.reverse();
	for( var i=0;i<err_stack.length;++i ){
		str+=err_stack[i]+"\n";
	}
	err_stack.reverse();
	pop_err();
	return str;
}

function print( str ){
	if( game_console ){
		game_console.value+=str+"\n";
	}
	if( window.console!=undefined ){
		window.console.log( str );
	}
}

function showError( err ){
	if( err.length ) alert( "Monkey runtime error: "+err+"\n"+stackTrace() );
}

function error( err ){
	throw err;
}

function dbg_object( obj ){
	if( obj ) return obj;
	error( "Null object access" );
}

function dbg_array( arr,index ){
	if( index>=0 && index<arr.length ) return arr;
	error( "Array index out of range" );
}

function new_bool_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=false;
	return arr;
}

function new_number_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=0;
	return arr;
}

function new_string_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]='';
	return arr;
}

function new_array_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=[];
	return arr;
}

function new_object_array( len ){
	var arr=Array( len );
	for( var i=0;i<len;++i ) arr[i]=null;
	return arr;
}

function resize_bool_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=false;
	return arr;
}

function resize_number_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=0;
	return arr;
}

function resize_string_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]="";
	return arr;
}

function resize_array_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=[];
	return arr;
}

function resize_object_array( arr,len ){
	var i=arr.length;
	arr=arr.slice(0,len);
	if( len<=i ) return arr;
	arr.length=len;
	while( i<len ) arr[i++]=null;
	return arr;
}

function string_compare( lhs,rhs ){
	var n=Math.min( lhs.length,rhs.length ),i,t;
	for( i=0;i<n;++i ){
		t=lhs.charCodeAt(i)-rhs.charCodeAt(i);
		if( t ) return t;
	}
	return lhs.length-rhs.length;
}

function string_replace( str,find,rep ){	//no unregex replace all?!?
	var i=0;
	for(;;){
		i=str.indexOf( find,i );
		if( i==-1 ) return str;
		str=str.substring( 0,i )+rep+str.substring( i+find.length );
		i+=rep.length;
	}
}

function string_trim( str ){
	var i=0,i2=str.length;
	while( i<i2 && str.charCodeAt(i)<=32 ) i+=1;
	while( i2>i && str.charCodeAt(i2-1)<=32 ) i2-=1;
	return str.slice( i,i2 );
}

function string_starts_with( str,substr ){
	return substr.length<=str.length && str.slice(0,substr.length)==substr;
}

function string_ends_with( str,substr ){
	return substr.length<=str.length && str.slice(str.length-substr.length,str.length)==substr;
}

function object_downcast( obj,clas ){
	if( obj instanceof clas ) return obj;
	return null;
}

function object_implements( obj,iface ){
	if( obj && obj.implments && obj.implments[iface] ) return obj;
	return null;
}

function extend_class( clas ){
	var tmp=function(){};
	tmp.prototype=clas.prototype;
	return new tmp;
}

// HTML5 mojo runtime.
//
// Copyright 2011 Mark Sibly, all rights reserved.
// No warranty implied; use at your own risk.

var dead=false;

var KEY_LMB=1;
var KEY_RMB=2;
var KEY_MMB=3;
var KEY_TOUCH0=0x180;

function eatEvent( e ){
	if( e.stopPropagation ){
		e.stopPropagation();
		e.preventDefault();
	}else{
		e.cancelBubble=true;
		e.returnValue=false;
	}
}

function keyToChar( key ){
	switch( key ){
	case 8:
	case 9:
	case 13:
	case 27:
	case 32:
		return key;
	case 33:
	case 34:
	case 35:
	case 36:
	case 37:
	case 38:
	case 39:
	case 40:
	case 45:
		return key | 0x10000;
	case 46:
		return 127;
	}
	return 0;
}

//***** gxtkApp class *****

function gxtkApp(){

	this.graphics=new gxtkGraphics( this,game_canvas );
	this.input=new gxtkInput( this );
	this.audio=new gxtkAudio( this );

	this.loading=0;
	this.maxloading=0;

	this.updateRate=0;
	
	this.startMillis=(new Date).getTime();
	
	this.suspended=false;
	
	var app=this;
	var canvas=game_canvas;
	
	function gxtkMain(){
		canvas.onkeydown=function( e ){
			app.input.OnKeyDown( e.keyCode );
			var chr=keyToChar( e.keyCode );
			if( chr ) app.input.PutChar( chr );
			if( e.keyCode<48 || (e.keyCode>111 && e.keyCode<122) ) eatEvent( e );
		}

		canvas.onkeyup=function( e ){
			app.input.OnKeyUp( e.keyCode );
		}

		canvas.onkeypress=function( e ){
			if( e.charCode ){
				app.input.PutChar( e.charCode );
			}else if( e.which ){
				app.input.PutChar( e.which );
			}
		}

		canvas.onmousedown=function( e ){
			switch( e.button ){
			case 0:app.input.OnKeyDown( KEY_LMB );break;
			case 1:app.input.OnKeyDown( KEY_MMB );break;
			case 2:app.input.OnKeyDown( KEY_RMB );break;
			}
			eatEvent( e );
		}
		
		canvas.onmouseup=function( e ){
			switch( e.button ){
			case 0:app.input.OnKeyUp( KEY_LMB );break;
			case 1:app.input.OnKeyUp( KEY_MMB );break;
			case 2:app.input.OnKeyUp( KEY_RMB );break;
			}
			eatEvent( e );
		}
		
		canvas.onmouseout=function( e ){
			app.input.OnKeyUp( KEY_LMB );
			app.input.OnKeyUp( KEY_MMB );
			app.input.OnKeyUp( KEY_RMB );
			eatEvent( e );
		}

		canvas.onmousemove=function( e ){
			var x=e.clientX+document.body.scrollLeft;
			var y=e.clientY+document.body.scrollTop;
			var c=canvas;
			while( c ){
				x-=c.offsetLeft;
				y-=c.offsetTop;
				c=c.offsetParent;
			}
			app.input.OnMouseMove( x,y );
			eatEvent( e );
		}

		canvas.onfocus=function( e ){
			//app.InvokeOnResume();
		}
		
		canvas.onblur=function( e ){
			//app.InvokeOnSuspend();
		}

		canvas.focus();

		app.InvokeOnCreate();
		app.InvokeOnRender();
	}
	
	game_runner=gxtkMain;
}

var timerSeq=0;

gxtkApp.prototype.SetFrameRate=function( fps ){

	var seq=++timerSeq;
	
	if( !fps ) return;
	
	var app=this;
	var updatePeriod=1000.0/fps;
	var nextUpdate=(new Date).getTime()+updatePeriod;
	
	function timeElapsed(){
		if( seq!=timerSeq ) return;

		var time;		
		var updates=0;

		for(;;){
			nextUpdate+=updatePeriod;

			app.InvokeOnUpdate();
			if( seq!=timerSeq ) return;
			
			if( nextUpdate>(new Date).getTime() ) break;
			
			if( ++updates==7 ){
				nextUpdate=(new Date).getTime();
				break;
			}
		}
		app.InvokeOnRender();
		if( seq!=timerSeq ) return;
			
		var delay=nextUpdate-(new Date).getTime();
		setTimeout( timeElapsed,delay>0 ? delay : 0 );
	}
	
	setTimeout( timeElapsed,updatePeriod );
}

gxtkApp.prototype.IncLoading=function(){
	++this.loading;
	if( this.loading>this.maxloading ) this.maxloading=this.loading;
	if( this.loading==1 ) this.SetFrameRate( 0 );
}

gxtkApp.prototype.DecLoading=function(){
	--this.loading;
	if( this.loading!=0 ) return;
	this.maxloading=0;
	this.SetFrameRate( this.updateRate );
}

gxtkApp.prototype.GetMetaData=function( path,key ){
	return getMetaData( path,key );
}

gxtkApp.prototype.Die=function( err ){
	dead=true;
	this.audio.OnSuspend();
	showError( err );
}

gxtkApp.prototype.InvokeOnCreate=function(){
	if( dead ) return;
	
	try{
		this.OnCreate();
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnUpdate=function(){
	if( dead || this.suspended || !this.updateRate || this.loading ) return;
	
	try{
		this.input.BeginUpdate();
		this.OnUpdate();		
		this.input.EndUpdate();
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnSuspend=function(){
	if( dead || this.suspended ) return;
	
	try{
		this.suspended=true;
		this.OnSuspend();
		this.audio.OnSuspend();
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnResume=function(){
	if( dead || !this.suspended ) return;
	
	try{
		this.audio.OnResume();
		this.OnResume();
		this.suspended=false;
	}catch( ex ){
		this.Die( ex );
	}
}

gxtkApp.prototype.InvokeOnRender=function(){
	if( dead || this.suspended ) return;
	
	try{
		this.graphics.BeginRender();
		if( this.loading ){
			this.OnLoading();
		}else{
			this.OnRender();
		}
		this.graphics.EndRender();
	}catch( ex ){
		this.Die( ex );
	}
}

//***** GXTK API *****

gxtkApp.prototype.GraphicsDevice=function(){
	return this.graphics;
}

gxtkApp.prototype.InputDevice=function(){
	return this.input;
}

gxtkApp.prototype.AudioDevice=function(){
	return this.audio;
}

gxtkApp.prototype.AppTitle=function(){
	return document.URL;
}

gxtkApp.prototype.LoadState=function(){
	//use cookies for file:// URLS in FF and IE...
	if( document.URL.toLowerCase().substr(0,7)=="file://" &&
			(navigator.userAgent.indexOf( "Firefox" )!=-1 || navigator.userAgent.indexOf( "MSIE" )!=-1) ){
		var bits=document.cookie.split( ";" )
		if( bits.length!=1 ) return "";
		bits=bits[0].split( "=" );
		if( bits.length!=2 || bits[0]!=".mojostate" ) return "";
		return unescape( bits[1] );
	}else{
		var state=localStorage.getItem( ".mojostate@"+document.URL );
		if( state ) return state;
	}
	return "";
}

gxtkApp.prototype.SaveState=function( state ){
	//use cookies for file:// URLS in FF and IE...
	if( document.URL.toLowerCase().substr(0,7)=="file://" &&
			(navigator.userAgent.indexOf( "Firefox" )!=-1 || navigator.userAgent.indexOf( "MSIE" )!=-1) ){
		var exdate=new Date();
		exdate.setDate( exdate.getDate()+3650 );
		document.cookie=".mojostate="+escape( state )+"; expires="+exdate.toUTCString()
	}else{
		localStorage.setItem( ".mojostate@"+document.URL,state );
	}
}

gxtkApp.prototype.LoadString=function( path ){
	return loadString( path );
}

gxtkApp.prototype.SetUpdateRate=function( fps ){
	this.updateRate=fps;
	
	if( !this.loading ) this.SetFrameRate( fps );
}

gxtkApp.prototype.MilliSecs=function(){
	return ((new Date).getTime()-this.startMillis)|0;
}

gxtkApp.prototype.Loading=function(){
	return this.loading;
}

gxtkApp.prototype.OnCreate=function(){
}

gxtkApp.prototype.OnUpdate=function(){
}

gxtkApp.prototype.OnSuspend=function(){
}

gxtkApp.prototype.OnResume=function(){
}

gxtkApp.prototype.OnRender=function(){
}

gxtkApp.prototype.OnLoading=function(){
}

//***** gxtkGraphics class *****

function gxtkGraphics( app,canvas ){
	this.app=app;
	this.canvas=canvas;
	this.gc=canvas.getContext( '2d' );
	this.tmpCanvas=null;
	this.r=255;
	this.b=255;
	this.g=255;
	this.white=true;
	this.color="rgb(255,255,255)"
	this.alpha=1.0;
	this.blend="source-over";
	this.ix=1;this.iy=0;
	this.jx=0;this.jy=1;
	this.tx=0;this.ty=0;
	this.tformed=false;
	this.scissorX=0;
	this.scissorY=0;
	this.scissorWidth=0;
	this.scissorHeight=0;
	this.clipped=false;
}

gxtkGraphics.prototype.BeginRender=function(){
	this.gc.save();
}

gxtkGraphics.prototype.EndRender=function(){
	this.gc.restore();
}

gxtkGraphics.prototype.Width=function(){
	return this.canvas.width;
}

gxtkGraphics.prototype.Height=function(){
	return this.canvas.height;
}

gxtkGraphics.prototype.LoadSurface=function( path ){
	
	var app=this.app;
	
	function onloadfun(){
		app.DecLoading();
	}

	app.IncLoading();

	var image=loadImage( path,onloadfun );
	if( image ) return new gxtkSurface( image,this );

	app.DecLoading();
	return null;
}

gxtkGraphics.prototype.SetAlpha=function( alpha ){
	this.alpha=alpha;
	this.gc.globalAlpha=alpha;
}

gxtkGraphics.prototype.SetColor=function( r,g,b ){
	this.r=r;
	this.g=g;
	this.b=b;
	this.white=(r==255 && g==255 && b==255);
	this.color="rgb("+(r|0)+","+(g|0)+","+(b|0)+")";
	this.gc.fillStyle=this.color;
	this.gc.strokeStyle=this.color;
}

gxtkGraphics.prototype.SetBlend=function( blend ){
	switch( blend ){
	case 1:
		this.blend="lighter";
		break;
	default:
		this.blend="source-over";
	}
	this.gc.globalCompositeOperation=this.blend;
}

gxtkGraphics.prototype.SetScissor=function( x,y,w,h ){
	this.scissorX=x;
	this.scissorY=y;
	this.scissorWidth=w;
	this.scissorHeight=h;
	this.clipped=(x!=0 || y!=0 || w!=this.canvas.width || h!=this.canvas.height);
	this.gc.restore();
	this.gc.save();
	if( this.clipped ){
		this.gc.beginPath();
		this.gc.rect( x,y,w,h );
		this.gc.clip();
		this.gc.closePath();
	}
	this.gc.fillStyle=this.color;
	this.gc.strokeStyle=this.color;
	if( this.tformed ) this.gc.setTransform( this.ix,this.iy,this.jx,this.jy,this.tx,this.ty );
}

gxtkGraphics.prototype.SetMatrix=function( ix,iy,jx,jy,tx,ty ){
	this.ix=ix;this.iy=iy;
	this.jx=jx;this.jy=jy;
	this.tx=tx;this.ty=ty;
	this.gc.setTransform( ix,iy,jx,jy,tx,ty );
	this.tformed=(ix!=1 || iy!=0 || jx!=0 || jy!=1 || tx!=0 || ty!=0);
}

gxtkGraphics.prototype.Cls=function( r,g,b ){
	if( this.tformed ) this.gc.setTransform( 1,0,0,1,0,0 );
	this.gc.fillStyle="rgb("+(r|0)+","+(g|0)+","+(b|0)+")";
	this.gc.globalAlpha=1;
	this.gc.globalCompositeOperation="source-over";
	this.gc.fillRect( 0,0,this.canvas.width,this.canvas.height );
	this.gc.fillStyle=this.color;
	this.gc.globalAlpha=this.alpha;
	this.gc.globalCompositeOperation=this.blend;
	if( this.tformed ) this.gc.setTransform( this.ix,this.iy,this.jx,this.jy,this.tx,this.ty );
}

gxtkGraphics.prototype.DrawRect=function( x,y,w,h ){
	if( w<0 ){ x+=w;w=-w; }
	if( h<0 ){ y+=h;h=-h; }
	if( w<=0 || h<=0 ) return;
	//
	this.gc.fillRect( x,y,w,h );
}

gxtkGraphics.prototype.DrawLine=function( x1,y1,x2,y2 ){
	if( this.tformed ){
		var x1_t=x1 * this.ix + y1 * this.jx + this.tx;
		var y1_t=x1 * this.iy + y1 * this.jy + this.ty;
		var x2_t=x2 * this.ix + y2 * this.jx + this.tx;
		var y2_t=x2 * this.iy + y2 * this.jy + this.ty;
		this.gc.setTransform( 1,0,0,1,0,0 );
	  	this.gc.beginPath();
	  	this.gc.moveTo( x1_t,y1_t );
	  	this.gc.lineTo( x2_t,y2_t );
	  	this.gc.stroke();
	  	this.gc.closePath();
		this.gc.setTransform( this.ix,this.iy,this.jx,this.jy,this.tx,this.ty );
	}else{
	  	this.gc.beginPath();
	  	this.gc.moveTo( x1,y1 );
	  	this.gc.lineTo( x2,y2 );
	  	this.gc.stroke();
	  	this.gc.closePath();
	}
}

gxtkGraphics.prototype.DrawOval=function( x,y,w,h ){
	if( w<0 ){ x+=w;w=-w; }
	if( h<0 ){ y+=h;h=-h; }
	if( w<=0 || h<=0 ) return;
	//
  	var w2=w/2,h2=h/2;
	this.gc.save();
	this.gc.translate( x+w2,y+h2 );
	this.gc.scale( w2,h2 );
  	this.gc.beginPath();
	this.gc.arc( 0,0,1,0,Math.PI*2,false );
	this.gc.fill();
  	this.gc.closePath();
	this.gc.restore();
}

gxtkGraphics.prototype.DrawPoly=function( verts ){
	if( verts.length<6 ) return;
	this.gc.beginPath();
	this.gc.moveTo( verts[0],verts[1] );
	for( var i=2;i<verts.length;i+=2 ){
		this.gc.lineTo( verts[i],verts[i+1] );
	}
	this.gc.fill();
	this.gc.closePath();
}

gxtkGraphics.prototype.DrawSurface=function( surface,x,y ){
	if( !surface.image.complete ) return;
	
	if( this.white ){
		this.gc.drawImage( surface.image,x,y );
		return;
	}
	
	this.DrawImageTinted( surface.image,x,y,0,0,surface.swidth,surface.sheight );
}

gxtkGraphics.prototype.DrawSurface2=function( surface,x,y,srcx,srcy,srcw,srch ){
	if( !surface.image.complete ) return;

	if( srcw<0 ){ srcx+=srcw;srcw=-srcw; }
	if( srch<0 ){ srcy+=srch;srch=-srch; }
	if( srcw<=0 || srch<=0 ) return;

	if( this.white ){
		this.gc.drawImage( surface.image,srcx,srcy,srcw,srch,x,y,srcw,srch );
		return;
	}
	
	this.DrawImageTinted( surface.image,x,y,srcx,srcy,srcw,srch  );
}

gxtkGraphics.prototype.DrawImageTinted=function( image,dx,dy,sx,sy,sw,sh ){

	if( !this.tmpCanvas ){
		this.tmpCanvas=document.createElement( "canvas" );
	}

	if( sw>this.tmpCanvas.width || sh>this.tmpCanvas.height ){
		this.tmpCanvas.width=Math.max( sw,this.tmpCanvas.width );
		this.tmpCanvas.height=Math.max( sh,this.tmpCanvas.height );
	}
	
	var tgc=this.tmpCanvas.getContext( "2d" );
	
	tgc.globalCompositeOperation="copy";

	tgc.drawImage( image,sx,sy,sw,sh,0,0,sw,sh );
	
	var imgData=tgc.getImageData( 0,0,sw,sh );
	
	var p=imgData.data,sz=sw*sh*4,i;
	
	for( i=0;i<sz;i+=4 ){
		p[i]=p[i]*this.r/255;
		p[i+1]=p[i+1]*this.g/255;
		p[i+2]=p[i+2]*this.b/255;
	}
	
	tgc.putImageData( imgData,0,0 );
	
	this.gc.drawImage( this.tmpCanvas,0,0,sw,sh,dx,dy,sw,sh );
}

//***** gxtkSurface class *****

function gxtkSurface( image,graphics ){
	this.image=image;
	this.graphics=graphics;
	this.swidth=image.meta_width;
	this.sheight=image.meta_height;
}

//***** GXTK API *****

gxtkSurface.prototype.Discard=function(){
	if( this.image ){
		this.image=null;
	}
}

gxtkSurface.prototype.Width=function(){
	return this.swidth;
}

gxtkSurface.prototype.Height=function(){
	return this.sheight;
}

gxtkSurface.prototype.Loaded=function(){
	return this.image.complete;
}

//***** Class gxtkInput *****

function gxtkInput( app ){
	this.app=app;
	this.keyStates=new Array( 512 );
	this.charQueue=new Array( 32 );
	this.charPut=0;
	this.charGet=0;
	this.mouseX=0;
	this.mouseY=0;
	this.joyX=0;
	this.joyY=0;
	this.joyZ=0;
	this.accelX=0;
	this.accelY=0;
	this.accelZ=0;
	for( var i=0;i<512;++i ){
		this.keyStates[i]=0;
	}
}

gxtkInput.prototype.BeginUpdate=function(){
}

gxtkInput.prototype.EndUpdate=function(){
	for( var i=0;i<512;++i ){
		this.keyStates[i]&=0x100;
	}
	this.charGet=0;
	this.charPut=0;
}

gxtkInput.prototype.OnKeyDown=function( key ){
	if( (this.keyStates[key]&0x100)==0 ){
		this.keyStates[key]|=0x100;
		++this.keyStates[key];	
	}
}

gxtkInput.prototype.OnKeyUp=function( key ){
	this.keyStates[key]&=0xff;
}

gxtkInput.prototype.PutChar=function( char ){
	if( this.charPut-this.charGet<32 ){
		this.charQueue[this.charPut & 31]=char;
		this.charPut+=1;
	}
}

gxtkInput.prototype.OnMouseMove=function( x,y ){
	this.mouseX=x;
	this.mouseY=y;
}

//***** GXTK API *****

gxtkInput.prototype.SetKeyboardEnabled=function( enabled ){
	return 0;
}

gxtkInput.prototype.KeyDown=function( key ){
	if( key>0 && key<512 ){
		if( key==KEY_TOUCH0 ) key=KEY_LMB;
		return this.keyStates[key] >> 8;
	}
	return 0;
}

gxtkInput.prototype.KeyHit=function( key ){
	if( key>0 && key<512 ){
		if( key==KEY_TOUCH0 ) key=KEY_LMB;
		return this.keyStates[key] & 0xff;
	}
	return 0;
}

gxtkInput.prototype.GetChar=function(){
	if( this.charPut!=this.charGet ){
		var char=this.charQueue[this.charGet & 31];
		this.charGet+=1;
		return char;
	}
	return 0;
}

gxtkInput.prototype.MouseX=function(){
	return this.mouseX;
}

gxtkInput.prototype.MouseY=function(){
	return this.mouseY;
}

gxtkInput.prototype.JoyX=function( index ){
	return this.joyX;
}

gxtkInput.prototype.JoyY=function( index ){
	return this.joyY;
}

gxtkInput.prototype.JoyZ=function( index ){
	return this.joyZ;
}

gxtkInput.prototype.TouchX=function( index ){
	return this.mouseX;
}

gxtkInput.prototype.TouchY=function( index ){
	return this.mouseY;
}

gxtkInput.prototype.AccelX=function(){
	return 0;
}

gxtkInput.prototype.AccelY=function(){
	return 0;
}

gxtkInput.prototype.AccelZ=function(){
	return 0;
}


//***** gxtkChannel class *****
function gxtkChannel(){
	this.audio=null;
	this.sample=null;
	this.volume=1;
	this.pan=0;
	this.rate=1;
}

//***** gxtkAudio class *****
function gxtkAudio( app ){
	this.app=app;
	this.okay=typeof(Audio)!="undefined";
	this.nextchan=0;
	this.music=null;
	this.channels=new Array(33);
	for( var i=0;i<33;++i ){
		this.channels[i]=new gxtkChannel();
	}
}

gxtkAudio.prototype.OnSuspend=function(){
	var i;
	for( i=0;i<33;++i ){
		var chan=this.channels[i];
		if( chan.audio ) chan.audio.pause();
	}
}

gxtkAudio.prototype.OnResume=function(){
	var i;
	for( i=0;i<33;++i ){
		var chan=this.channels[i];
		if( chan.audio ) chan.audio.play();
	}
}

gxtkAudio.prototype.LoadSample=function( path ){
	var audio=loadAudio( path );
	if( audio ) return new gxtkSample( audio );
	return null;
}

gxtkAudio.prototype.PlaySample=function( sample,channel,flags ){
	if( !this.okay ) return;
	
	var chan=this.channels[channel];
	
	if( chan.sample==sample && chan.audio ){	//&& !chan.audio.paused ){
		chan.audio.loop=(flags&1)!=0;
		chan.audio.volume=chan.volume;
		try{
			chan.audio.currentTime=0;
		}catch(ex){
		}
		chan.audio.play();
		return;
	}

	if( chan.audio ) chan.audio.pause();
	
	var audio=sample.AllocAudio();
	
	if( audio ){
		for( var i=0;i<33;++i ){
			if( this.channels[i].audio==audio ){
				this.channels[i].audio=null;
				break;
			}
		}
		audio.loop=(flags&1)!=0;
		audio.volume=chan.volume;
		audio.play();
	}
	
	chan.audio=audio;
	chan.sample=sample;
}

gxtkAudio.prototype.StopChannel=function( channel ){
	var chan=this.channels[channel];
	if( chan.audio ) chan.audio.pause();
}

gxtkAudio.prototype.ChannelState=function( channel ){
	var chan=this.channels[channel];
	if( chan.audio && !chan.audio.paused && !chan.audio.ended ) return 1;
	return 0;
}

gxtkAudio.prototype.SetVolume=function( channel,volume ){
	var chan=this.channels[channel];
	if( chan.audio ) chan.audio.volume=volume;
	chan.volume=volume;
}

gxtkAudio.prototype.SetPan=function( channel,pan ){
	var chan=this.channels[channel];
	chan.pan=pan;
}

gxtkAudio.prototype.SetRate=function( channel,rate ){
	var chan=this.channels[channel];
	chan.rate=rate;
}

gxtkAudio.prototype.PlayMusic=function( path,flags ){
	this.StopMusic();
	
	this.music=this.LoadSample( path );
	if( !this.music ) return;
	
	this.PlaySample( this.music,32,flags );
}

gxtkAudio.prototype.StopMusic=function(){
	this.StopChannel( 32 );

	if( this.music ){
		this.music.Discard();
		this.music=null;
	}
}

gxtkAudio.prototype.MusicState=function(){

	return this.ChannelState( 32 );
}

gxtkAudio.prototype.SetMusicVolume=function( volume ){

	this.SetVolume( 32,volume );
}

//***** gxtkSample class *****

function gxtkSample( audio ){
	this.audio=audio;
	this.insts=new Array( 8 );
	this.insts[0]=audio;
}

gxtkSample.prototype.Discard=function(){
	if( this.audio ){
		this.audio=null;
		for( var i=0;i<8;++i ){
			this.insts[i]=null;
		}
	}
}

gxtkSample.prototype.AllocAudio=function(){
	for( var i=0;i<8;++i ){
		var audio=this.insts[i];
		if( audio ){
			//Ok, this is ugly but seems to work best...no idea how/why!
			if( audio.paused ){
				if( audio.currentTime==0 ) return audio;
				audio.currentTime=0;
			}else if( audio.ended ){
				audio.pause();
			}
		}else{
			audio=new Audio( this.audio.src );
			this.insts[i]=audio;
			return audio;
		}
	}
	return null;
}
function bb_app_App(){
	Object.call(this);
}
function bb_app_new(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<109>";
	bb_app_device=bb_app_new2.call(new bb_app_AppDevice,this);
	pop_err();
	return this;
}
bb_app_App.prototype.bbm_OnCreate=function(){
	push_err();
	pop_err();
	return 0;
}
bb_app_App.prototype.bbm_OnUpdate=function(){
	push_err();
	pop_err();
	return 0;
}
bb_app_App.prototype.bbm_OnSuspend=function(){
	push_err();
	pop_err();
	return 0;
}
bb_app_App.prototype.bbm_OnResume=function(){
	push_err();
	pop_err();
	return 0;
}
bb_app_App.prototype.bbm_OnRender=function(){
	push_err();
	pop_err();
	return 0;
}
bb_app_App.prototype.bbm_OnLoading=function(){
	push_err();
	pop_err();
	return 0;
}
function bb_dred_Bisko(){
	bb_app_App.call(this);
}
bb_dred_Bisko.prototype=extend_class(bb_app_App);
function bb_dred_new(){
	push_err();
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<19>";
	bb_app_new.call(this);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<19>";
	var bbt_=this;
	pop_err();
	return bbt_;
}
var bb_dred_road1;
var bb_dred_road2;
var bb_dred_cactus;
var bb_dred_car;
var bb_dred_car2;
var bb_dred_wheels;
var bb_dred_eyes;
var bb_dred_tower;
var bb_dred_bat;
var bb_dred_cross;
var bb_dred_cross2;
var bb_dred_mount;
var bb_dred_x;
var bb_dred_y;
var bb_dred_dx;
var bb_dred_angle;
var bb_dred_score;
var bb_dred_best;
var bb_dred_crossPos;
var bb_dred_crossOfs;
var bb_dred_crossTimer;
var bb_dred_crosstype;
var bb_dred_roadY;
var bb_dred_roadH;
var bb_dred_roadW;
var bb_dred_roadX;
bb_dred_Bisko.prototype.bbm_OnCreate=function(){
	push_err();
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<41>";
	bb_random_Seed=bb_app_Millisecs();
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<43>";
	bb_app_SetUpdateRate(60);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<44>";
	bb_dred_road1=bb_graphics_LoadImage("road1.png",1,1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<45>";
	bb_dred_road2=bb_graphics_LoadImage("road2.png",1,1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<46>";
	bb_dred_cactus=bb_graphics_LoadImage("cactus.png",1,bb_graphics_DefaultFlags);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<47>";
	bb_dred_cactus.bbm_SetHandle(29.0,64.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<48>";
	bb_dred_car=bb_graphics_LoadImage("car.png",1,1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<49>";
	bb_dred_car2=bb_graphics_LoadImage("car2.png",1,1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<50>";
	bb_dred_wheels=bb_graphics_LoadImage("wheels.png",1,1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<51>";
	bb_dred_eyes=bb_graphics_LoadImage("eyes.png",8,1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<52>";
	bb_dred_tower=bb_graphics_LoadImage("tower.png",1,bb_graphics_DefaultFlags);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<53>";
	bb_dred_tower.bbm_SetHandle(35.0,250.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<54>";
	bb_dred_bat=bb_graphics_LoadImage("bat.png",4,1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<55>";
	bb_dred_cross=bb_graphics_LoadImage("cruci.png",1,bb_graphics_DefaultFlags);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<56>";
	bb_dred_cross.bbm_SetHandle(16.0,32.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<57>";
	bb_dred_cross2=bb_graphics_LoadImage("wolf.png",1,bb_graphics_DefaultFlags);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<58>";
	bb_dred_cross2.bbm_SetHandle(16.0,32.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<59>";
	bb_dred_mount=bb_graphics_LoadImage("mountains.png",1,bb_graphics_DefaultFlags);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<60>";
	bb_dred_mount.bbm_SetHandle(350.0,64.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<61>";
	bb_dred_x=320.0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<62>";
	bb_dred_y=400.0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<63>";
	bb_dred_dx=0.0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<64>";
	bb_dred_angle=0.0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<66>";
	bb_dred_score=0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<67>";
	bb_dred_best=0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<69>";
	bb_dred_crossPos=19;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<70>";
	bb_dred_crossOfs=-64.0+bb_random_Rnd3(129.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<71>";
	bb_dred_crossTimer=0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<72>";
	bb_dred_crosstype=0;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<74>";
	dbg_array(bb_dred_roadY,0)[0]=480
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<75>";
	dbg_array(bb_dred_roadH,0)[0]=4.0
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<76>";
	dbg_array(bb_dred_roadW,0)[0]=4.0
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<77>";
	dbg_array(bb_dred_roadX,0)[0]=320
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<79>";
	for(var bbt_i=1;bbt_i<=19;bbt_i=bbt_i+1){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<80>";
		var bbt_=bbt_i-1;
		dbg_array(bb_dred_roadW,bbt_i)[bbt_i]=dbg_array(bb_dred_roadW,bbt_)[bbt_]*0.8
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<81>";
		var bbt_2=bbt_i-1;
		dbg_array(bb_dred_roadH,bbt_i)[bbt_i]=dbg_array(bb_dred_roadH,bbt_2)[bbt_2]*0.8
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<82>";
		dbg_array(bb_dred_roadX,bbt_i)[bbt_i]=320
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<83>";
		var bbt_3=bbt_i-1;
		var bbt_4=bbt_i-1;
		dbg_array(bb_dred_roadY,bbt_i)[bbt_i]=(((dbg_array(bb_dred_roadY,bbt_3)[bbt_3])-dbg_array(bb_dred_roadH,bbt_4)[bbt_4]/2.0*16.0-dbg_array(bb_dred_roadH,bbt_i)[bbt_i]/2.0*16.0+3.0)|0)
	}
	pop_err();
	return 0;
}
var bb_dred_dead;
var bb_dred_start;
var bb_dred_timer;
var bb_dred_speed;
var bb_dred_linetimer;
var bb_dred_crossGot;
var bb_dred_curvetimer;
var bb_dred_bend;
var bb_dred_battimer;
var bb_dred_batx;
var bb_dred_baty;
var bb_dred_batd;
var bb_dred_batdx;
var bb_dred_batdy;
var bb_dred_hill;
var bb_dred_hilly;
var bb_dred_jump;
var bb_dred_batdead;
var bb_dred_batscale;
var bb_dred_batframe;
bb_dred_Bisko.prototype.bbm_OnUpdate=function(){
	push_err();
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<91>";
	if(!bb_dred_dead && !bb_dred_start){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<92>";
		bb_dred_timer+=1.0;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<93>";
		if(((bb_dred_timer)|0) % ((bb_dred_speed)|0)==0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<94>";
			bb_dred_linetimer+=1;
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<101>";
		bb_dred_crossTimer+=1;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<103>";
		bb_dred_score+=1;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<105>";
		if(bb_dred_crossTimer>100){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<106>";
			if(((bb_dred_timer)|0) % 10==1){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<107>";
				bb_dred_crossPos-=1;
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<110>";
			if(bb_dred_crossPos<0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<111>";
				bb_dred_crossPos=19;
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<112>";
				bb_dred_crossTimer=0;
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<113>";
				bb_dred_crossOfs=-64.0+bb_random_Rnd3(129.0);
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<114>";
				bb_dred_crosstype=0;
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<118>";
		if(bb_dred_crossPos<=2){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<120>";
			if(bb_dred_Distance(bb_dred_x,bb_dred_y,(dbg_array(bb_dred_roadX,bb_dred_crossPos)[bb_dred_crossPos])+bb_dred_crossOfs*dbg_array(bb_dred_roadW,bb_dred_crossPos)[bb_dred_crossPos],(dbg_array(bb_dred_roadY,bb_dred_crossPos)[bb_dred_crossPos]))<64.0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<121>";
				bb_dred_crossGot=300;
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<125>";
		if(bb_dred_crossGot>0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<125>";
			bb_dred_crossGot-=1;
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<128>";
		if(bb_dred_speed>2.0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<128>";
			bb_dred_speed-=0.001;
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<130>";
		bb_dred_curvetimer+=1;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<132>";
		if(((bb_dred_timer)|0) % 40==0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<132>";
			bb_dred_bend=((bb_random_Rnd3(7.0))|0);
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<134>";
		if(((bb_dred_timer)|0) % 400==0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<135>";
			bb_dred_battimer=1;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<136>";
			bb_dred_batx=320.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<137>";
			bb_dred_baty=64.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<138>";
			bb_dred_batd=100.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<139>";
			bb_dred_batdx=bb_random_Rnd2(32.0,608.0);
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<140>";
			bb_dred_batdy=bb_random_Rnd2(32.0,400.0);
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<144>";
		if(bb_dred_bend==1){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<145>";
			dbg_array(bb_dred_roadX,19)[19]=((320.0+Math.sin((bb_dred_timer*4.0)*D2R)*512.0)|0)
		}else{
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<146>";
			if(bb_dred_bend==2){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<147>";
				dbg_array(bb_dred_roadX,19)[19]+=1
			}else{
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<148>";
				if(bb_dred_bend==3){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<149>";
					dbg_array(bb_dred_roadX,19)[19]-=1
				}else{
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<150>";
					if(bb_dred_bend==4){
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<151>";
						dbg_array(bb_dred_roadX,19)[19]+=5
					}else{
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<152>";
						if(bb_dred_bend==5){
							err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<153>";
							dbg_array(bb_dred_roadX,19)[19]-=5
						}else{
							err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<154>";
							if(bb_dred_bend==6){
								err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<155>";
								if(dbg_array(bb_dred_roadX,19)[19]<320){
									err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<155>";
									dbg_array(bb_dred_roadX,19)[19]+=1
								}
								err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<156>";
								if(dbg_array(bb_dred_roadX,19)[19]>320){
									err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<156>";
									dbg_array(bb_dred_roadX,19)[19]-=1
								}
							}
						}
					}
				}
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<161>";
		var bbt_c=200;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<162>";
		if(bb_dred_hill==0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<162>";
			bbt_c=400;
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<164>";
		if(bb_random_Rnd3(bbt_c)<1.0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<164>";
			bb_dred_hill=((bb_random_Rnd3(3.0))|0);
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<165>";
		if(bb_dred_hill==0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<166>";
			if(bb_dred_hilly<0.8){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<166>";
				bb_dred_hilly+=0.0005;
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<167>";
			if(bb_dred_hilly>0.8){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<167>";
				bb_dred_hilly-=0.0005;
			}
		}else{
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<168>";
			if(bb_dred_hill==1){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<169>";
				if(bb_dred_hilly<1.0){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<169>";
					bb_dred_hilly+=0.0005;
				}
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<170>";
				if(bb_dred_hilly>1.0){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<170>";
					bb_dred_hilly-=0.0005;
				}
			}else{
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<171>";
				if(bb_dred_hill==2){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<172>";
					if(bb_dred_hilly<0.6){
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<172>";
						bb_dred_hilly+=0.0005;
					}
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<173>";
					if(bb_dred_hilly>0.6){
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<173>";
						bb_dred_hilly-=0.0005;
					}
				}
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<177>";
		if(bb_dred_curvetimer % ((bb_dred_speed)|0)==0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<178>";
			for(var bbt_i=0;bbt_i<=18;bbt_i=bbt_i+1){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<179>";
				var bbt_=bbt_i+1;
				dbg_array(bb_dred_roadW,bbt_)[bbt_]=dbg_array(bb_dred_roadW,bbt_i)[bbt_i]*bb_dred_hilly
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<180>";
				if(bb_dred_hilly<0.8){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<180>";
					var bbt_2=bbt_i+1;
					dbg_array(bb_dred_roadH,bbt_2)[bbt_2]=dbg_array(bb_dred_roadH,bbt_i)[bbt_i]*bb_dred_hilly
				}
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<181>";
				var bbt_3=bbt_i+1;
				var bbt_4=bbt_i+1;
				dbg_array(bb_dred_roadX,bbt_i)[bbt_i]=dbg_array(bb_dred_roadX,bbt_3)[bbt_3]-(((dbg_array(bb_dred_roadX,bbt_4)[bbt_4]-320)/bbt_i)|0)
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<189>";
		bb_dred_x+=(dbg_array(bb_dred_roadX,0)[0]-dbg_array(bb_dred_roadX,10)[10])*0.02;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<191>";
		if((bb_input_KeyDown(39))!=0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<192>";
			bb_dred_dx=1.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<193>";
			if(bb_dred_jump==0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<194>";
				bb_dred_x+=3.0;
			}else{
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<196>";
				bb_dred_x+=12.0;
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<198>";
			if(bb_dred_jump==0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<198>";
				bb_dred_angle=-10.0;
			}
		}else{
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<199>";
			if((bb_input_KeyDown(37))!=0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<200>";
				if(bb_dred_jump==0){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<201>";
					bb_dred_x-=3.0;
				}else{
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<203>";
					bb_dred_x-=12.0;
				}
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<205>";
				bb_dred_dx=-1.0;
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<206>";
				if(bb_dred_jump==0){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<206>";
					bb_dred_angle=10.0;
				}
			}else{
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<208>";
				if(bb_dred_jump==0){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<209>";
					bb_dred_angle=0.0;
				}else{
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<211>";
					bb_dred_dx=0.0;
				}
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<215>";
		if((bb_input_KeyDown(38))!=0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<216>";
			if(bb_dred_jump==0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<216>";
				bb_dred_jump=30;
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<220>";
		if(bb_dred_jump>15){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<221>";
			bb_dred_jump-=1;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<222>";
			bb_dred_y-=20.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<223>";
			bb_dred_angle+=bb_dred_dx*-10.0;
		}else{
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<224>";
			if(bb_dred_jump>0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<225>";
				bb_dred_jump-=1;
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<226>";
				if(bb_dred_y<400.0){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<226>";
					bb_dred_y+=20.0;
				}
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<227>";
				bb_dred_angle+=bb_dred_dx*-10.0;
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<231>";
		if(bb_dred_x<320.0-dbg_array(bb_dred_roadW,0)[0]/2.0*100.0 || bb_dred_x>320.0+dbg_array(bb_dred_roadW,0)[0]/2.0*100.0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<232>";
			bb_dred_angle+=bb_random_Rnd2(-10.0,10.0);
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<235>";
		if(bb_dred_x<320.0-dbg_array(bb_dred_roadW,0)[0]/2.0*128.0-64.0 || bb_dred_x>320.0+dbg_array(bb_dred_roadW,0)[0]/2.0*128.0+64.0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<236>";
			bb_dred_dead=true;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<237>";
			bb_dred_crossGot=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<238>";
			bb_dred_batdead=true;
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<241>";
		if(bb_dred_battimer==1){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<242>";
			if(bb_dred_batscale>3.0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<243>";
				if(bb_dred_Distance(bb_dred_x,bb_dred_y,bb_dred_batx,bb_dred_baty)<64.0){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<244>";
					if(bb_dred_crossGot>0){
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<245>";
						bb_dred_batdead=true;
					}else{
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<247>";
						bb_dred_batdead=false;
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<248>";
						bb_dred_dead=true;
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<249>";
						bb_dred_crossGot=0;
					}
				}
			}
		}
	}else{
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<255>";
		if(!bb_dred_start){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<256>";
			bb_dred_angle=180.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<258>";
			if(bb_dred_y<400.0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<258>";
				bb_dred_y+=20.0;
			}
		}
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<263>";
	if(bb_dred_battimer==1){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<264>";
		if(!bb_dred_dead){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<265>";
			bb_dred_batd-=1.0;
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<269>";
		bb_dred_batx+=(bb_dred_batdx-bb_dred_batx)*0.002;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<270>";
		bb_dred_baty+=(bb_dred_batdy-bb_dred_baty)*0.002;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<273>";
		if(bb_dred_batdead){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<274>";
			bb_dred_batdy=-999.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<275>";
			if(bb_dred_baty<-64.0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<276>";
				bb_dred_battimer=0;
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<277>";
				bb_dred_batdead=false;
			}
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<281>";
		if(bb_dred_dead && !bb_dred_batdead){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<282>";
			bb_dred_batx-=(bb_dred_batx-bb_dred_x)*0.5+bb_random_Rnd2(-5.0,5.0);
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<283>";
			bb_dred_baty-=(bb_dred_baty-bb_dred_y)*0.5+bb_random_Rnd2(-5.0,5.0);
		}
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<287>";
	if(bb_dred_score>bb_dred_best){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<287>";
		bb_dred_best=bb_dred_score;
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<289>";
	if(bb_dred_dead || bb_dred_start){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<290>";
		if((bb_input_KeyDown(32))!=0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<291>";
			bb_dred_dead=false;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<292>";
			bb_dred_start=false;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<293>";
			bb_dred_batdead=false;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<294>";
			bb_dred_x=320.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<295>";
			bb_dred_y=400.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<296>";
			bb_dred_dx=0.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<297>";
			bb_dred_battimer=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<298>";
			bb_dred_score=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<300>";
			bb_dred_crossPos=19;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<301>";
			bb_dred_crossOfs=-64.0+bb_random_Rnd3(129.0);
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<302>";
			bb_dred_crossTimer=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<303>";
			bb_dred_crosstype=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<305>";
			dbg_array(bb_dred_roadY,0)[0]=480
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<306>";
			dbg_array(bb_dred_roadH,0)[0]=4.0
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<307>";
			dbg_array(bb_dred_roadW,0)[0]=4.0
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<308>";
			dbg_array(bb_dred_roadX,0)[0]=320
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<310>";
			for(var bbt_i2=1;bbt_i2<=19;bbt_i2=bbt_i2+1){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<311>";
				var bbt_5=bbt_i2-1;
				dbg_array(bb_dred_roadW,bbt_i2)[bbt_i2]=dbg_array(bb_dred_roadW,bbt_5)[bbt_5]*0.8
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<312>";
				var bbt_6=bbt_i2-1;
				dbg_array(bb_dred_roadH,bbt_i2)[bbt_i2]=dbg_array(bb_dred_roadH,bbt_6)[bbt_6]*0.8
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<313>";
				dbg_array(bb_dred_roadX,bbt_i2)[bbt_i2]=320
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<314>";
				var bbt_7=bbt_i2-1;
				var bbt_8=bbt_i2-1;
				dbg_array(bb_dred_roadY,bbt_i2)[bbt_i2]=(((dbg_array(bb_dred_roadY,bbt_7)[bbt_7])-dbg_array(bb_dred_roadH,bbt_8)[bbt_8]/2.0*16.0-dbg_array(bb_dred_roadH,bbt_i2)[bbt_i2]/2.0*16.0+3.0)|0)
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<317>";
			bb_dred_timer=0.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<318>";
			bb_dred_linetimer=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<319>";
			bb_dred_curvetimer=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<320>";
			bb_dred_speed=4.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<321>";
			bb_dred_angle=0.0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<322>";
			bb_dred_batframe=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<323>";
			bb_dred_bend=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<324>";
			bb_dred_hill=0;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<325>";
			bb_dred_hilly=0.8;
		}
	}
	pop_err();
	return 0;
}
var bb_dred_cactusfx;
var bb_dred_cactusheight;
bb_dred_Bisko.prototype.bbm_OnRender=function(){
	push_err();
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<338>";
	bb_graphics_SetAlpha(0.1);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<340>";
	for(var bbt_i=0;bbt_i<=240;bbt_i=bbt_i+2){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<341>";
		bb_graphics_SetColor((bbt_i)+Math.sin((bb_dred_timer/10.0)*D2R)*100.0,0.0,(bbt_i)+Math.sin((bb_dred_timer/10.0+180.0)*D2R)*100.0);
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<342>";
		bb_graphics_DrawRect(0.0,(bbt_i),640.0,2.0);
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<345>";
	bb_graphics_DrawCircle(320.0,50.0,50.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<347>";
	bb_graphics_SetAlpha(1.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<350>";
	bb_graphics_SetColor(bb_random_Rnd3(255.0),bb_random_Rnd3(255.0),bb_random_Rnd3(255.0));
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<351>";
	bb_graphics_DrawImage(bb_dred_tower,320.0+(320-dbg_array(bb_dred_roadX,10)[10])*0.05,260.0,0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<353>";
	bb_graphics_SetAlpha(0.2);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<354>";
	bb_graphics_SetColor(0.0,0.0,0.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<355>";
	bb_graphics_DrawRect(0.0,240.0,640.0,480.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<357>";
	bb_graphics_SetAlpha(1.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<358>";
	bb_graphics_SetColor(255.0,255.0,255.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<360>";
	var bbt_crossR=bb_dred_crossPos;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<362>";
	for(var bbt_i2=0;bbt_i2<=19;bbt_i2=bbt_i2+1){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<363>";
		var bbt_ang=0.0;
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<365>";
		if(bbt_i2>0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<366>";
			var bbt_=bbt_i2-1;
			bbt_ang=Math.sin((dbg_array(bb_dred_roadX,bbt_)[bbt_]-dbg_array(bb_dred_roadX,bbt_i2)[bbt_i2])*D2R)*60.0;
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<369>";
		if(bbt_i2 % 2==bb_dred_linetimer % 2){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<370>";
			bb_graphics_DrawImage2(bb_dred_road1,(dbg_array(bb_dred_roadX,bbt_i2)[bbt_i2]),(dbg_array(bb_dred_roadY,bbt_i2)[bbt_i2]),bbt_ang,dbg_array(bb_dred_roadW,bbt_i2)[bbt_i2],dbg_array(bb_dred_roadH,bbt_i2)[bbt_i2],0);
		}else{
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<372>";
			bb_graphics_DrawImage2(bb_dred_road2,(dbg_array(bb_dred_roadX,bbt_i2)[bbt_i2]),(dbg_array(bb_dred_roadY,bbt_i2)[bbt_i2]),bbt_ang,dbg_array(bb_dred_roadW,bbt_i2)[bbt_i2],dbg_array(bb_dred_roadH,bbt_i2)[bbt_i2],0);
		}
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<380>";
	if(bb_dred_crossTimer>100){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<381>";
		if(bb_dred_crosstype==0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<382>";
			bb_graphics_SetColor(bb_random_Rnd3(255.0),bb_random_Rnd3(255.0),bb_random_Rnd3(255.0));
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<383>";
			bb_graphics_DrawImage2(bb_dred_cross,(dbg_array(bb_dred_roadX,bbt_crossR)[bbt_crossR])+bb_dred_crossOfs*dbg_array(bb_dred_roadW,bbt_crossR)[bbt_crossR],(dbg_array(bb_dred_roadY,bbt_crossR)[bbt_crossR]),0.0,0.5*dbg_array(bb_dred_roadW,bbt_crossR)[bbt_crossR],0.5*dbg_array(bb_dred_roadW,bbt_crossR)[bbt_crossR],0);
		}else{
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<385>";
			bb_graphics_DrawImage2(bb_dred_cross2,(dbg_array(bb_dred_roadX,bbt_crossR)[bbt_crossR])+bb_dred_crossOfs*dbg_array(bb_dred_roadW,bbt_crossR)[bbt_crossR],(dbg_array(bb_dred_roadY,bbt_crossR)[bbt_crossR]),0.0,0.5*dbg_array(bb_dred_roadW,bbt_crossR)[bbt_crossR],0.5*dbg_array(bb_dred_roadW,bbt_crossR)[bbt_crossR],0);
		}
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<387>";
		bb_graphics_SetColor(255.0,255.0,255.0);
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<391>";
	for(var bbt_i3=19;bbt_i3>=0;bbt_i3=bbt_i3+-1){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<392>";
		if(bbt_i3 % 2==bb_dred_linetimer % 2){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<393>";
			bb_graphics_SetColor(Math.sin((bb_dred_timer/4.0+180.0)*D2R)*100.0,100.0+Math.sin((bb_dred_timer/12.0+90.0)*D2R)*100.0,Math.sin((bb_dred_timer/4.0)*D2R)*200.0);
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<394>";
			if(bb_dred_cactusfx==0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<395>";
				bb_graphics_DrawImage2(bb_dred_cactus,(dbg_array(bb_dred_roadX,bbt_i3)[bbt_i3])-dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*128.0,(dbg_array(bb_dred_roadY,bbt_i3)[bbt_i3]),0.0,dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*2.0,dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*2.0,0);
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<396>";
				bb_graphics_DrawImage2(bb_dred_cactus,(dbg_array(bb_dred_roadX,bbt_i3)[bbt_i3])+dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*128.0,(dbg_array(bb_dred_roadY,bbt_i3)[bbt_i3]),0.0,dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*2.0,dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*2.0,0);
			}else{
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<397>";
				if(bb_dred_cactusfx==1){
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<398>";
					bb_graphics_DrawImage2(bb_dred_cactus,(dbg_array(bb_dred_roadX,bbt_i3)[bbt_i3])-dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*128.0,(dbg_array(bb_dred_roadY,bbt_i3)[bbt_i3]),Math.sin((bb_dred_timer)*D2R)*-45.0-45.0,dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3],dbg_array(bb_dred_roadH,bbt_i3)[bbt_i3]*bb_dred_cactusheight,0);
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<399>";
					bb_graphics_DrawImage2(bb_dred_cactus,(dbg_array(bb_dred_roadX,bbt_i3)[bbt_i3])+dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*128.0,(dbg_array(bb_dred_roadY,bbt_i3)[bbt_i3]),Math.sin((bb_dred_timer)*D2R)*45.0+45.0,dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3],dbg_array(bb_dred_roadH,bbt_i3)[bbt_i3]*bb_dred_cactusheight,0);
				}else{
					err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<400>";
					if(bb_dred_cactusfx==2){
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<401>";
						bb_graphics_DrawImage2(bb_dred_cactus,(dbg_array(bb_dred_roadX,bbt_i3)[bbt_i3])-dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*128.0,(dbg_array(bb_dred_roadY,bbt_i3)[bbt_i3]),bb_random_Rnd3(360.0),dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3],dbg_array(bb_dred_roadH,bbt_i3)[bbt_i3]*bb_dred_cactusheight,0);
						err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<402>";
						bb_graphics_DrawImage2(bb_dred_cactus,(dbg_array(bb_dred_roadX,bbt_i3)[bbt_i3])+dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3]*128.0,(dbg_array(bb_dred_roadY,bbt_i3)[bbt_i3]),bb_random_Rnd3(360.0),dbg_array(bb_dred_roadW,bbt_i3)[bbt_i3],dbg_array(bb_dred_roadH,bbt_i3)[bbt_i3]*bb_dred_cactusheight,0);
					}
				}
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<405>";
			bb_graphics_SetColor(255.0,255.0,255.0);
		}
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<409>";
	if(bb_dred_battimer==1){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<410>";
		if(bb_dred_batscale<3.0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<411>";
			if(((bb_dred_timer)|0) % 2==0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<411>";
				bb_dred_batframe+=1;
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<412>";
			bb_dred_batscale=(100.0-bb_dred_batd)*0.01;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<413>";
			bb_graphics_SetColor(255.0,bb_random_Rnd3(255.0),bb_random_Rnd3(255.0));
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<414>";
			if(bb_dred_dead && !bb_dred_batdead){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<415>";
				bb_graphics_DrawImage2(bb_dred_bat,bb_dred_batx,bb_dred_baty,bb_random_Rnd2(-45.0,45.0),bb_dred_batscale,bb_dred_batscale,bb_dred_batframe % 4);
			}else{
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<417>";
				bb_graphics_DrawImage2(bb_dred_bat,bb_dred_batx,bb_dred_baty,0.0,bb_dred_batscale,bb_dred_batscale,bb_dred_batframe % 4);
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<419>";
			bb_graphics_SetColor(255.0,255.0,255.0);
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<420>";
			if(bb_dred_batd==-500.0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<421>";
				bb_dred_battimer=0;
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<422>";
				bb_dred_batdead=false;
			}
		}
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<428>";
	if(bb_dred_jump==0 && !bb_dred_dead){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<429>";
		bb_graphics_DrawImage2(bb_dred_wheels,bb_dred_x,bb_dred_y,0.0,1.0,1.0,0);
	}else{
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<431>";
		bb_graphics_DrawImage2(bb_dred_wheels,bb_dred_x,bb_dred_y,bb_dred_angle,1.0,1.0,0);
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<433>";
	if(bb_dred_crossGot>0){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<434>";
		if(((bb_dred_timer)|0) % 8<4){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<435>";
			bb_graphics_DrawImage2(bb_dred_car,bb_dred_x,bb_dred_y,bb_dred_angle,1.0,1.0,0);
		}else{
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<437>";
			bb_graphics_DrawImage2(bb_dred_car2,bb_dred_x,bb_dred_y,bb_dred_angle,1.0,1.0,0);
		}
	}else{
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<440>";
		bb_graphics_DrawImage2(bb_dred_car,bb_dred_x,bb_dred_y,bb_dred_angle,1.0,1.0,0);
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<444>";
	bb_graphics_DrawImage2(bb_dred_eyes,bb_dred_x,bb_dred_y-38.0,bb_dred_angle,1.0,1.0,bb_dred_linetimer % 6);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<446>";
	if(bb_dred_battimer==1){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<447>";
		if(bb_dred_batscale>=3.0){
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<448>";
			if(((bb_dred_timer)|0) % 2==0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<448>";
				bb_dred_batframe+=1;
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<449>";
			bb_dred_batscale=(100.0-bb_dred_batd)*0.01;
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<450>";
			bb_graphics_SetColor(255.0,bb_random_Rnd3(255.0),bb_random_Rnd3(255.0));
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<451>";
			if(bb_dred_dead && !bb_dred_batdead){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<452>";
				bb_graphics_DrawImage2(bb_dred_bat,bb_dred_batx,bb_dred_baty,bb_random_Rnd2(-45.0,45.0),bb_dred_batscale,bb_dred_batscale,bb_dred_batframe % 4);
			}else{
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<454>";
				bb_graphics_DrawImage2(bb_dred_bat,bb_dred_batx,bb_dred_baty,0.0,bb_dred_batscale,bb_dred_batscale,bb_dred_batframe % 4);
			}
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<456>";
			bb_graphics_SetColor(255.0,255.0,255.0);
			err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<457>";
			if(bb_dred_batd==-500.0){
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<458>";
				bb_dred_battimer=0;
				err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<459>";
				bb_dred_batdead=false;
			}
		}
	}
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<464>";
	bb_graphics_DrawText(String(bb_dred_score)+" MILES",0.0,0.0,0.0,0.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<465>";
	bb_graphics_DrawText("BEST: "+String(bb_dred_best)+" MILES",640.0,0.0,1.0,0.0);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<467>";
	if(bb_dred_dead || bb_dred_start){
		err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<469>";
		bb_graphics_DrawText("CONTROLS: LEFT/RIGHT TO STEER, UP TO JUMP. PRESS SPACE TO PLAY.",320.0,480.0,0.5,1.0);
	}
	pop_err();
	return 0;
}
function bb_app_AppDevice(){
	gxtkApp.call(this);
	this.bb_app=null;
	this.bb_updateRate=0;
}
bb_app_AppDevice.prototype=extend_class(gxtkApp);
function bb_app_new2(bbt_app){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<47>";
	dbg_object(this).bb_app=bbt_app;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<48>";
	bb_graphics_SetGraphicsContext(bb_graphics_new.call(new bb_graphics_GraphicsContext,this.GraphicsDevice()));
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<49>";
	bb_input_SetInputDevice(this.InputDevice());
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<50>";
	bb_audio_SetAudioDevice(this.AudioDevice());
	pop_err();
	return this;
}
function bb_app_new3(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<44>";
	var bbt_=this;
	pop_err();
	return bbt_;
}
bb_app_AppDevice.prototype.OnCreate=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<54>";
	bb_graphics_SetFont(null,32);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<55>";
	var bbt_=this.bb_app.bbm_OnCreate();
	pop_err();
	return bbt_;
}
bb_app_AppDevice.prototype.OnUpdate=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<59>";
	var bbt_=this.bb_app.bbm_OnUpdate();
	pop_err();
	return bbt_;
}
bb_app_AppDevice.prototype.OnSuspend=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<63>";
	var bbt_=this.bb_app.bbm_OnSuspend();
	pop_err();
	return bbt_;
}
bb_app_AppDevice.prototype.OnResume=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<67>";
	var bbt_=this.bb_app.bbm_OnResume();
	pop_err();
	return bbt_;
}
bb_app_AppDevice.prototype.OnRender=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<71>";
	bb_graphics_BeginRender();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<72>";
	var bbt_r=this.bb_app.bbm_OnRender();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<73>";
	bb_graphics_EndRender();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<74>";
	pop_err();
	return bbt_r;
}
bb_app_AppDevice.prototype.OnLoading=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<78>";
	bb_graphics_BeginRender();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<79>";
	var bbt_r=this.bb_app.bbm_OnLoading();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<80>";
	bb_graphics_EndRender();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<81>";
	pop_err();
	return bbt_r;
}
bb_app_AppDevice.prototype.SetUpdateRate=function(bbt_hertz){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<85>";
	gxtkApp.prototype.SetUpdateRate.call(this,bbt_hertz);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<86>";
	this.bb_updateRate=bbt_hertz;
	pop_err();
	return 0;
}
function bb_graphics_GraphicsContext(){
	Object.call(this);
	this.bb_device=null;
	this.bb_defaultFont=null;
	this.bb_font=null;
	this.bb_firstChar=0;
	this.bb_matrixSp=0;
	this.bb_ix=1.0;
	this.bb_iy=.0;
	this.bb_jx=.0;
	this.bb_jy=1.0;
	this.bb_tx=.0;
	this.bb_ty=.0;
	this.bb_tformed=0;
	this.bb_matDirty=0;
	this.bb_color_r=.0;
	this.bb_color_g=.0;
	this.bb_color_b=.0;
	this.bb_alpha=.0;
	this.bb_blend=0;
	this.bb_scissor_x=.0;
	this.bb_scissor_y=.0;
	this.bb_scissor_width=.0;
	this.bb_scissor_height=.0;
	this.bb_matrixStack=new_number_array(192);
}
function bb_graphics_new(bbt_device){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<207>";
	dbg_object(this).bb_device=bbt_device;
	pop_err();
	return this;
}
function bb_graphics_new2(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<204>";
	var bbt_=this;
	pop_err();
	return bbt_;
}
var bb_graphics_context;
function bb_graphics_SetGraphicsContext(bbt_gc){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<246>";
	bb_graphics_context=bbt_gc;
	pop_err();
	return 0;
}
var bb_input_device;
function bb_input_SetInputDevice(bbt_dev){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/input.monkey<40>";
	bb_input_device=bbt_dev;
	pop_err();
	return 0;
}
var bb_audio_device;
function bb_audio_SetAudioDevice(bbt_dev){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/audio.monkey<56>";
	bb_audio_device=bbt_dev;
	pop_err();
	return 0;
}
var bb_app_device;
function bbMain(){
	push_err();
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<509>";
	bb_dred_new.call(new bb_dred_Bisko);
	pop_err();
	return 0;
}
function bb_graphics_Image(){
	Object.call(this);
	this.bb_surface=null;
	this.bb_width=0;
	this.bb_height=0;
	this.bb_frames=[];
	this.bb_flags=0;
	this.bb_tx=.0;
	this.bb_ty=.0;
	this.bb_source=null;
}
var bb_graphics_DefaultFlags;
function bb_graphics_new3(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<62>";
	var bbt_=this;
	pop_err();
	return bbt_;
}
bb_graphics_Image.prototype.bbm_SetHandle=function(bbt_tx,bbt_ty){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<106>";
	dbg_object(this).bb_tx=bbt_tx;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<107>";
	dbg_object(this).bb_ty=bbt_ty;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<108>";
	dbg_object(this).bb_flags=dbg_object(this).bb_flags&-2;
	pop_err();
	return 0;
}
bb_graphics_Image.prototype.bbm_ApplyFlags=function(bbt_iflags){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<177>";
	this.bb_flags=bbt_iflags;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<179>";
	if((this.bb_flags&2)!=0){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<180>";
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<180>";
		var bbt_=this.bb_frames;
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<180>";
		var bbt_2=0;
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<180>";
		while(bbt_2<bbt_.length){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<180>";
			var bbt_f=dbg_array(bbt_,bbt_2)[bbt_2];
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<180>";
			bbt_2=bbt_2+1;
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<181>";
			dbg_object(bbt_f).bb_x+=1;
		}
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<183>";
		this.bb_width-=2;
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<186>";
	if((this.bb_flags&4)!=0){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<187>";
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<187>";
		var bbt_3=this.bb_frames;
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<187>";
		var bbt_4=0;
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<187>";
		while(bbt_4<bbt_3.length){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<187>";
			var bbt_f2=dbg_array(bbt_3,bbt_4)[bbt_4];
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<187>";
			bbt_4=bbt_4+1;
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<188>";
			dbg_object(bbt_f2).bb_y+=1;
		}
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<190>";
		this.bb_height-=2;
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<193>";
	if((this.bb_flags&1)!=0){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<194>";
		this.bbm_SetHandle((this.bb_width)/2.0,(this.bb_height)/2.0);
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<197>";
	if(this.bb_frames.length==1 && dbg_object(dbg_array(this.bb_frames,0)[0]).bb_x==0 && dbg_object(dbg_array(this.bb_frames,0)[0]).bb_y==0 && this.bb_width==this.bb_surface.Width() && this.bb_height==this.bb_surface.Height()){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<198>";
		this.bb_flags|=65536;
	}
	pop_err();
	return 0;
}
bb_graphics_Image.prototype.bbm_Load=function(bbt_path,bbt_nframes,bbt_iflags){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<129>";
	this.bb_surface=dbg_object(bb_graphics_context).bb_device.LoadSurface(bbt_path);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<130>";
	if(!((this.bb_surface)!=null)){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<130>";
		pop_err();
		return null;
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<132>";
	this.bb_width=((this.bb_surface.Width()/bbt_nframes)|0);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<133>";
	this.bb_height=this.bb_surface.Height();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<135>";
	this.bb_frames=new_object_array(bbt_nframes);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<137>";
	for(var bbt_i=0;bbt_i<bbt_nframes;bbt_i=bbt_i+1){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<138>";
		dbg_array(this.bb_frames,bbt_i)[bbt_i]=bb_graphics_new4.call(new bb_graphics_Frame,bbt_i*this.bb_width,0)
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<141>";
	this.bbm_ApplyFlags(bbt_iflags);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<143>";
	var bbt_=this;
	pop_err();
	return bbt_;
}
bb_graphics_Image.prototype.bbm_Grab=function(bbt_x,bbt_y,bbt_iwidth,bbt_iheight,bbt_nframes,bbt_iflags,bbt_source){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<148>";
	dbg_object(this).bb_source=bbt_source;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<149>";
	this.bb_surface=dbg_object(bbt_source).bb_surface;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<151>";
	this.bb_width=bbt_iwidth;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<152>";
	this.bb_height=bbt_iheight;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<154>";
	this.bb_frames=new_object_array(bbt_nframes);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<156>";
	var bbt_ix=bbt_x+dbg_object(dbg_array(dbg_object(bbt_source).bb_frames,0)[0]).bb_x;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<157>";
	var bbt_iy=bbt_y+dbg_object(dbg_array(dbg_object(bbt_source).bb_frames,0)[0]).bb_y;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<159>";
	for(var bbt_i=0;bbt_i<bbt_nframes;bbt_i=bbt_i+1){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<160>";
		if(bbt_ix+this.bb_width>dbg_object(bbt_source).bb_width){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<161>";
			bbt_ix=dbg_object(dbg_array(dbg_object(bbt_source).bb_frames,0)[0]).bb_x;
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<162>";
			bbt_iy+=this.bb_height;
		}
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<164>";
		if(bbt_ix+this.bb_width>dbg_object(bbt_source).bb_width || bbt_iy+this.bb_height>dbg_object(bbt_source).bb_height){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<165>";
			error("Image frame outside surface");
		}
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<167>";
		dbg_array(this.bb_frames,bbt_i)[bbt_i]=bb_graphics_new4.call(new bb_graphics_Frame,bbt_ix,bbt_iy)
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<168>";
		bbt_ix+=this.bb_width;
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<171>";
	this.bbm_ApplyFlags(bbt_iflags);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<173>";
	var bbt_=this;
	pop_err();
	return bbt_;
}
bb_graphics_Image.prototype.bbm_GrabImage=function(bbt_x,bbt_y,bbt_width,bbt_height,bbt_frames,bbt_flags){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<101>";
	if(dbg_object(this).bb_frames.length!=1){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<101>";
		pop_err();
		return null;
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<102>";
	var bbt_=(bb_graphics_new3.call(new bb_graphics_Image)).bbm_Grab(bbt_x,bbt_y,bbt_width,bbt_height,bbt_frames,bbt_flags,this);
	pop_err();
	return bbt_;
}
bb_graphics_Image.prototype.bbm_Width=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<73>";
	pop_err();
	return this.bb_width;
}
bb_graphics_Image.prototype.bbm_Height=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<77>";
	pop_err();
	return this.bb_height;
}
bb_graphics_Image.prototype.bbm_Frames=function(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<85>";
	var bbt_=this.bb_frames.length;
	pop_err();
	return bbt_;
}
function bb_graphics_Frame(){
	Object.call(this);
	this.bb_x=0;
	this.bb_y=0;
}
function bb_graphics_new4(bbt_x,bbt_y){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<54>";
	dbg_object(this).bb_x=bbt_x;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<55>";
	dbg_object(this).bb_y=bbt_y;
	pop_err();
	return this;
}
function bb_graphics_new5(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<49>";
	var bbt_=this;
	pop_err();
	return bbt_;
}
function bb_graphics_LoadImage(bbt_path,bbt_frameCount,bbt_flags){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<272>";
	var bbt_=(bb_graphics_new3.call(new bb_graphics_Image)).bbm_Load(bbt_path,bbt_frameCount,bbt_flags);
	pop_err();
	return bbt_;
}
function bb_graphics_LoadImage2(bbt_path,bbt_frameWidth,bbt_frameHeight,bbt_frameCount,bbt_flags){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<276>";
	var bbt_atlas=(bb_graphics_new3.call(new bb_graphics_Image)).bbm_Load(bbt_path,1,0);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<277>";
	if((bbt_atlas)!=null){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<277>";
		var bbt_=bbt_atlas.bbm_GrabImage(0,0,bbt_frameWidth,bbt_frameHeight,bbt_frameCount,bbt_flags);
		pop_err();
		return bbt_;
	}
	pop_err();
	return null;
}
function bb_graphics_SetFont(bbt_font,bbt_firstChar){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<537>";
	if(!((bbt_font)!=null)){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<538>";
		if(!((dbg_object(bb_graphics_context).bb_defaultFont)!=null)){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<539>";
			dbg_object(bb_graphics_context).bb_defaultFont=bb_graphics_LoadImage("mojo_font.png",96,2);
		}
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<541>";
		bbt_font=dbg_object(bb_graphics_context).bb_defaultFont;
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<542>";
		bbt_firstChar=32;
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<544>";
	dbg_object(bb_graphics_context).bb_font=bbt_font;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<545>";
	dbg_object(bb_graphics_context).bb_firstChar=bbt_firstChar;
	pop_err();
	return 0;
}
var bb_graphics_renderDevice;
function bb_graphics_SetMatrix(bbt_ix,bbt_iy,bbt_jx,bbt_jy,bbt_tx,bbt_ty){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<326>";
	dbg_object(bb_graphics_context).bb_ix=bbt_ix;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<327>";
	dbg_object(bb_graphics_context).bb_iy=bbt_iy;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<328>";
	dbg_object(bb_graphics_context).bb_jx=bbt_jx;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<329>";
	dbg_object(bb_graphics_context).bb_jy=bbt_jy;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<330>";
	dbg_object(bb_graphics_context).bb_tx=bbt_tx;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<331>";
	dbg_object(bb_graphics_context).bb_ty=bbt_ty;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<332>";
	dbg_object(bb_graphics_context).bb_tformed=((bbt_ix!=1.0 || bbt_iy!=0.0 || bbt_jx!=0.0 || bbt_jy!=1.0 || bbt_tx!=0.0 || bbt_ty!=0.0)?1:0);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<333>";
	dbg_object(bb_graphics_context).bb_matDirty=1;
	pop_err();
	return 0;
}
function bb_graphics_SetMatrix2(bbt_m){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<322>";
	bb_graphics_SetMatrix(dbg_array(bbt_m,0)[0],dbg_array(bbt_m,1)[1],dbg_array(bbt_m,2)[2],dbg_array(bbt_m,3)[3],dbg_array(bbt_m,4)[4],dbg_array(bbt_m,5)[5]);
	pop_err();
	return 0;
}
function bb_graphics_SetColor(bbt_r,bbt_g,bbt_b){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<281>";
	dbg_object(bb_graphics_context).bb_color_r=bbt_r;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<282>";
	dbg_object(bb_graphics_context).bb_color_g=bbt_g;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<283>";
	dbg_object(bb_graphics_context).bb_color_b=bbt_b;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<284>";
	dbg_object(bb_graphics_context).bb_device.SetColor(bbt_r,bbt_g,bbt_b);
	pop_err();
	return 0;
}
function bb_graphics_SetAlpha(bbt_alpha){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<292>";
	dbg_object(bb_graphics_context).bb_alpha=bbt_alpha;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<293>";
	dbg_object(bb_graphics_context).bb_device.SetAlpha(bbt_alpha);
	pop_err();
	return 0;
}
function bb_graphics_SetBlend(bbt_blend){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<301>";
	dbg_object(bb_graphics_context).bb_blend=bbt_blend;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<302>";
	dbg_object(bb_graphics_context).bb_device.SetBlend(bbt_blend);
	pop_err();
	return 0;
}
function bb_graphics_DeviceWidth(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<264>";
	var bbt_=dbg_object(bb_graphics_context).bb_device.Width();
	pop_err();
	return bbt_;
}
function bb_graphics_DeviceHeight(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<268>";
	var bbt_=dbg_object(bb_graphics_context).bb_device.Height();
	pop_err();
	return bbt_;
}
function bb_graphics_SetScissor(bbt_x,bbt_y,bbt_width,bbt_height){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<310>";
	dbg_object(bb_graphics_context).bb_scissor_x=bbt_x;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<311>";
	dbg_object(bb_graphics_context).bb_scissor_y=bbt_y;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<312>";
	dbg_object(bb_graphics_context).bb_scissor_width=bbt_width;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<313>";
	dbg_object(bb_graphics_context).bb_scissor_height=bbt_height;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<314>";
	dbg_object(bb_graphics_context).bb_device.SetScissor(((bbt_x)|0),((bbt_y)|0),((bbt_width)|0),((bbt_height)|0));
	pop_err();
	return 0;
}
function bb_graphics_BeginRender(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<250>";
	bb_graphics_renderDevice=dbg_object(bb_graphics_context).bb_device;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<251>";
	dbg_object(bb_graphics_context).bb_matrixSp=0;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<252>";
	bb_graphics_SetMatrix(1.0,0.0,0.0,1.0,0.0,0.0);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<253>";
	bb_graphics_SetColor(255.0,255.0,255.0);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<254>";
	bb_graphics_SetAlpha(1.0);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<255>";
	bb_graphics_SetBlend(0);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<256>";
	bb_graphics_SetScissor(0.0,0.0,(bb_graphics_DeviceWidth()),(bb_graphics_DeviceHeight()));
	pop_err();
	return 0;
}
function bb_graphics_EndRender(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<260>";
	bb_graphics_renderDevice=null;
	pop_err();
	return 0;
}
function bb_app_Millisecs(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<157>";
	var bbt_=bb_app_device.MilliSecs();
	pop_err();
	return bbt_;
}
var bb_random_Seed;
function bb_app_SetUpdateRate(bbt_hertz){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/app.monkey<149>";
	var bbt_=bb_app_device.SetUpdateRate(bbt_hertz);
	pop_err();
	return bbt_;
}
function bb_random_Rnd(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/monkey/random.monkey<21>";
	bb_random_Seed=bb_random_Seed*1664525+1013904223|0;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/monkey/random.monkey<22>";
	var bbt_=(bb_random_Seed>>8&16777215)/16777216.0;
	pop_err();
	return bbt_;
}
function bb_random_Rnd2(bbt_low,bbt_high){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/monkey/random.monkey<30>";
	var bbt_=bb_random_Rnd3(bbt_high-bbt_low)+bbt_low;
	pop_err();
	return bbt_;
}
function bb_random_Rnd3(bbt_range){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/monkey/random.monkey<26>";
	var bbt_=bb_random_Rnd()*bbt_range;
	pop_err();
	return bbt_;
}
function bb_dred_Distance(bbt_x1,bbt_y1,bbt_x2,bbt_y2){
	push_err();
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<11>";
	var bbt_distX=bbt_x1-bbt_x2;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<12>";
	var bbt_distY=bbt_y1-bbt_y2;
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<13>";
	var bbt_dist=Math.sqrt(bbt_distX*bbt_distX+bbt_distY*bbt_distY);
	err_info="/Users/brandon/Documents/CODE/_MONKEY_/racings/dred.monkey<15>";
	pop_err();
	return bbt_dist;
}
function bb_input_KeyDown(bbt_key){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/input.monkey<73>";
	var bbt_=bb_input_device.KeyDown(bbt_key);
	pop_err();
	return bbt_;
}
function bb_graphics_DebugRenderDevice(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<237>";
	if(!((bb_graphics_renderDevice)!=null)){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<237>";
		error("Rendering operations can only be performed inside OnRender");
	}
	pop_err();
	return 0;
}
function bb_graphics_ValidateMatrix(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<230>";
	if((dbg_object(bb_graphics_context).bb_matDirty)!=0){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<231>";
		dbg_object(bb_graphics_context).bb_device.SetMatrix(dbg_object(bb_graphics_context).bb_ix,dbg_object(bb_graphics_context).bb_iy,dbg_object(bb_graphics_context).bb_jx,dbg_object(bb_graphics_context).bb_jy,dbg_object(bb_graphics_context).bb_tx,dbg_object(bb_graphics_context).bb_ty);
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<232>";
		dbg_object(bb_graphics_context).bb_matDirty=0;
	}
	pop_err();
	return 0;
}
function bb_graphics_DrawRect(bbt_x,bbt_y,bbt_w,bbt_h){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<388>";
	bb_graphics_DebugRenderDevice();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<390>";
	bb_graphics_ValidateMatrix();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<391>";
	bb_graphics_renderDevice.DrawRect(bbt_x,bbt_y,bbt_w,bbt_h);
	pop_err();
	return 0;
}
function bb_graphics_DrawCircle(bbt_x,bbt_y,bbt_r){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<412>";
	bb_graphics_DebugRenderDevice();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<414>";
	bb_graphics_ValidateMatrix();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<415>";
	bb_graphics_renderDevice.DrawOval(bbt_x-bbt_r,bbt_y-bbt_r,bbt_r*2.0,bbt_r*2.0);
	pop_err();
	return 0;
}
function bb_graphics_PushMatrix(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<341>";
	var bbt_sp=dbg_object(bb_graphics_context).bb_matrixSp;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<342>";
	var bbt_=bbt_sp+0;
	dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_)[bbt_]=dbg_object(bb_graphics_context).bb_ix
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<343>";
	var bbt_2=bbt_sp+1;
	dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_2)[bbt_2]=dbg_object(bb_graphics_context).bb_iy
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<344>";
	var bbt_3=bbt_sp+2;
	dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_3)[bbt_3]=dbg_object(bb_graphics_context).bb_jx
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<345>";
	var bbt_4=bbt_sp+3;
	dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_4)[bbt_4]=dbg_object(bb_graphics_context).bb_jy
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<346>";
	var bbt_5=bbt_sp+4;
	dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_5)[bbt_5]=dbg_object(bb_graphics_context).bb_tx
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<347>";
	var bbt_6=bbt_sp+5;
	dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_6)[bbt_6]=dbg_object(bb_graphics_context).bb_ty
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<348>";
	dbg_object(bb_graphics_context).bb_matrixSp=bbt_sp+6;
	pop_err();
	return 0;
}
function bb_graphics_Transform(bbt_ix,bbt_iy,bbt_jx,bbt_jy,bbt_tx,bbt_ty){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<358>";
	var bbt_ix2=bbt_ix*dbg_object(bb_graphics_context).bb_ix+bbt_iy*dbg_object(bb_graphics_context).bb_jx;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<359>";
	var bbt_iy2=bbt_ix*dbg_object(bb_graphics_context).bb_iy+bbt_iy*dbg_object(bb_graphics_context).bb_jy;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<360>";
	var bbt_jx2=bbt_jx*dbg_object(bb_graphics_context).bb_ix+bbt_jy*dbg_object(bb_graphics_context).bb_jx;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<361>";
	var bbt_jy2=bbt_jx*dbg_object(bb_graphics_context).bb_iy+bbt_jy*dbg_object(bb_graphics_context).bb_jy;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<362>";
	var bbt_tx2=bbt_tx*dbg_object(bb_graphics_context).bb_ix+bbt_ty*dbg_object(bb_graphics_context).bb_jx+dbg_object(bb_graphics_context).bb_tx;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<363>";
	var bbt_ty2=bbt_tx*dbg_object(bb_graphics_context).bb_iy+bbt_ty*dbg_object(bb_graphics_context).bb_jy+dbg_object(bb_graphics_context).bb_ty;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<364>";
	bb_graphics_SetMatrix(bbt_ix2,bbt_iy2,bbt_jx2,bbt_jy2,bbt_tx2,bbt_ty2);
	pop_err();
	return 0;
}
function bb_graphics_Transform2(bbt_coords){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<582>";
	var bbt_out=new_number_array(bbt_coords.length);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<583>";
	for(var bbt_i=0;bbt_i<bbt_coords.length-1;bbt_i=bbt_i+2){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<584>";
		var bbt_x=dbg_array(bbt_coords,bbt_i)[bbt_i];
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<584>";
		var bbt_=bbt_i+1;
		var bbt_y=dbg_array(bbt_coords,bbt_)[bbt_];
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<585>";
		dbg_array(bbt_out,bbt_i)[bbt_i]=bbt_x*dbg_object(bb_graphics_context).bb_ix+bbt_y*dbg_object(bb_graphics_context).bb_jx+dbg_object(bb_graphics_context).bb_tx
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<586>";
		var bbt_2=bbt_i+1;
		dbg_array(bbt_out,bbt_2)[bbt_2]=bbt_x*dbg_object(bb_graphics_context).bb_iy+bbt_y*dbg_object(bb_graphics_context).bb_jy+dbg_object(bb_graphics_context).bb_ty
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<588>";
	pop_err();
	return bbt_out;
}
function bb_graphics_Translate(bbt_x,bbt_y){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<368>";
	bb_graphics_Transform(1.0,0.0,0.0,1.0,bbt_x,bbt_y);
	pop_err();
	return 0;
}
function bb_graphics_PopMatrix(){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<352>";
	var bbt_sp=dbg_object(bb_graphics_context).bb_matrixSp-6;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<353>";
	var bbt_=bbt_sp+0;
	var bbt_2=bbt_sp+1;
	var bbt_3=bbt_sp+2;
	var bbt_4=bbt_sp+3;
	var bbt_5=bbt_sp+4;
	var bbt_6=bbt_sp+5;
	bb_graphics_SetMatrix(dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_)[bbt_],dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_2)[bbt_2],dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_3)[bbt_3],dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_4)[bbt_4],dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_5)[bbt_5],dbg_array(dbg_object(bb_graphics_context).bb_matrixStack,bbt_6)[bbt_6]);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<354>";
	dbg_object(bb_graphics_context).bb_matrixSp=bbt_sp;
	pop_err();
	return 0;
}
function bb_graphics_DrawImage(bbt_image,bbt_x,bbt_y,bbt_frame){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<436>";
	bb_graphics_DebugRenderDevice();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<438>";
	var bbt_f=dbg_array(dbg_object(bbt_image).bb_frames,bbt_frame)[bbt_frame];
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<440>";
	if((dbg_object(bb_graphics_context).bb_tformed)!=0){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<441>";
		bb_graphics_PushMatrix();
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<443>";
		bb_graphics_Translate(bbt_x-dbg_object(bbt_image).bb_tx,bbt_y-dbg_object(bbt_image).bb_ty);
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<445>";
		bb_graphics_ValidateMatrix();
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<447>";
		if((dbg_object(bbt_image).bb_flags&65536)!=0){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<448>";
			dbg_object(bb_graphics_context).bb_device.DrawSurface(dbg_object(bbt_image).bb_surface,0.0,0.0);
		}else{
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<450>";
			dbg_object(bb_graphics_context).bb_device.DrawSurface2(dbg_object(bbt_image).bb_surface,0.0,0.0,dbg_object(bbt_f).bb_x,dbg_object(bbt_f).bb_y,dbg_object(bbt_image).bb_width,dbg_object(bbt_image).bb_height);
		}
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<453>";
		bb_graphics_PopMatrix();
	}else{
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<455>";
		bb_graphics_ValidateMatrix();
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<457>";
		if((dbg_object(bbt_image).bb_flags&65536)!=0){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<458>";
			dbg_object(bb_graphics_context).bb_device.DrawSurface(dbg_object(bbt_image).bb_surface,bbt_x-dbg_object(bbt_image).bb_tx,bbt_y-dbg_object(bbt_image).bb_ty);
		}else{
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<460>";
			dbg_object(bb_graphics_context).bb_device.DrawSurface2(dbg_object(bbt_image).bb_surface,bbt_x-dbg_object(bbt_image).bb_tx,bbt_y-dbg_object(bbt_image).bb_ty,dbg_object(bbt_f).bb_x,dbg_object(bbt_f).bb_y,dbg_object(bbt_image).bb_width,dbg_object(bbt_image).bb_height);
		}
	}
	pop_err();
	return 0;
}
function bb_graphics_Rotate(bbt_angle){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<376>";
	bb_graphics_Transform(Math.cos((bbt_angle)*D2R),-Math.sin((bbt_angle)*D2R),Math.sin((bbt_angle)*D2R),Math.cos((bbt_angle)*D2R),0.0,0.0);
	pop_err();
	return 0;
}
function bb_graphics_Scale(bbt_x,bbt_y){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<372>";
	bb_graphics_Transform(bbt_x,0.0,0.0,bbt_y,0.0,0.0);
	pop_err();
	return 0;
}
function bb_graphics_DrawImage2(bbt_image,bbt_x,bbt_y,bbt_rotation,bbt_scaleX,bbt_scaleY,bbt_frame){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<467>";
	bb_graphics_DebugRenderDevice();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<469>";
	var bbt_f=dbg_array(dbg_object(bbt_image).bb_frames,bbt_frame)[bbt_frame];
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<471>";
	bb_graphics_PushMatrix();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<473>";
	bb_graphics_Translate(bbt_x,bbt_y);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<474>";
	bb_graphics_Rotate(bbt_rotation);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<475>";
	bb_graphics_Scale(bbt_scaleX,bbt_scaleY);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<477>";
	bb_graphics_Translate(-dbg_object(bbt_image).bb_tx,-dbg_object(bbt_image).bb_ty);
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<479>";
	bb_graphics_ValidateMatrix();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<481>";
	if((dbg_object(bbt_image).bb_flags&65536)!=0){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<482>";
		dbg_object(bb_graphics_context).bb_device.DrawSurface(dbg_object(bbt_image).bb_surface,0.0,0.0);
	}else{
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<484>";
		dbg_object(bb_graphics_context).bb_device.DrawSurface2(dbg_object(bbt_image).bb_surface,0.0,0.0,dbg_object(bbt_f).bb_x,dbg_object(bbt_f).bb_y,dbg_object(bbt_image).bb_width,dbg_object(bbt_image).bb_height);
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<487>";
	bb_graphics_PopMatrix();
	pop_err();
	return 0;
}
function bb_graphics_DrawText(bbt_text,bbt_x,bbt_y,bbt_xalign,bbt_yalign){
	push_err();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<562>";
	bb_graphics_DebugRenderDevice();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<564>";
	if(!((dbg_object(bb_graphics_context).bb_font)!=null)){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<564>";
		pop_err();
		return 0;
	}
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<566>";
	var bbt_w=dbg_object(bb_graphics_context).bb_font.bbm_Width();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<567>";
	var bbt_h=dbg_object(bb_graphics_context).bb_font.bbm_Height();
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<569>";
	bbt_x-=(bbt_w*bbt_text.length)*bbt_xalign;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<570>";
	bbt_y-=(bbt_h)*bbt_yalign;
	err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<572>";
	for(var bbt_i=0;bbt_i<bbt_text.length;bbt_i=bbt_i+1){
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<573>";
		var bbt_ch=bbt_text.charCodeAt(bbt_i)-dbg_object(bb_graphics_context).bb_firstChar;
		err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<574>";
		if(bbt_ch>=0 && bbt_ch<dbg_object(bb_graphics_context).bb_font.bbm_Frames()){
			err_info="/Users/brandon/Downloads/MonkeyDemo45c/modules/mojo/graphics.monkey<575>";
			bb_graphics_DrawImage(dbg_object(bb_graphics_context).bb_font,bbt_x+(bbt_i*bbt_w),bbt_y,bbt_ch);
		}
	}
	pop_err();
	return 0;
}
function bbInit(){
	bb_graphics_context=null;
	bb_input_device=null;
	bb_audio_device=null;
	bb_app_device=null;
	bb_graphics_DefaultFlags=0;
	bb_graphics_renderDevice=null;
	bb_random_Seed=1234;
	bb_dred_road1=null;
	bb_dred_road2=null;
	bb_dred_cactus=null;
	bb_dred_car=null;
	bb_dred_car2=null;
	bb_dred_wheels=null;
	bb_dred_eyes=null;
	bb_dred_tower=null;
	bb_dred_bat=null;
	bb_dred_cross=null;
	bb_dred_cross2=null;
	bb_dred_mount=null;
	bb_dred_x=.0;
	bb_dred_y=.0;
	bb_dred_dx=.0;
	bb_dred_angle=0.0;
	bb_dred_score=0;
	bb_dred_best=0;
	bb_dred_crossPos=0;
	bb_dred_crossOfs=.0;
	bb_dred_crossTimer=0;
	bb_dred_crosstype=0;
	bb_dred_roadY=new_number_array(20);
	bb_dred_roadH=new_number_array(20);
	bb_dred_roadW=new_number_array(20);
	bb_dred_roadX=new_number_array(20);
	bb_dred_dead=false;
	bb_dred_start=true;
	bb_dred_timer=0.0;
	bb_dred_speed=4.0;
	bb_dred_linetimer=0;
	bb_dred_crossGot=0;
	bb_dred_curvetimer=0;
	bb_dred_bend=0;
	bb_dred_battimer=0;
	bb_dred_batx=.0;
	bb_dred_baty=.0;
	bb_dred_batd=.0;
	bb_dred_batdx=.0;
	bb_dred_batdy=.0;
	bb_dred_hill=0;
	bb_dred_hilly=0.8;
	bb_dred_jump=0;
	bb_dred_batdead=false;
	bb_dred_batscale=.0;
	bb_dred_batframe=0;
	bb_dred_cactusfx=0;
	bb_dred_cactusheight=1.0;
}
//${TRANSCODE_END}
